unit crCueBanner;

interface
uses Windows
     {$if CompilerVersion < 20.00}
       //  partir de D2009 vous devez activer les styles les options du projet
     , XPMan
     {$else}
       //  partir de D2009 les fonctions "Edit_SetCueBannerText" & "Edit_GetCueBannerText"
       // existent dj. Nous les utiliserons par redirection.
     , CommCtrl
     {$ifend};

// fonction tandue permettant le choix ShowOnFocus: Boolean
// qui permet ou non de voir le Cue Banner Text quand l'edit  le focus
// active pour toutes les versions de Delphi
function Edit_SetCueBannerTextEx(hwnd: HWND; CueText: PWideChar; ShowOnFocus: Boolean = True): BOOL;{$if CompilerVersion >= 20.00} inline; {$ifend}


{$if CompilerVersion < 20.00}
//avant D2009 nous devons les dclarer et les implmenter
function Edit_SetCueBannerText(hwnd: HWND; CueText: PWideChar): BOOL;
function Edit_GetCueBannerText(hwnd: HWND; CueText: PWideChar; BufLen: Longint): BOOL;
{$else}
// comme elle existent depuis D2009
type
TEdit_SetCueBannerText = function (hwnd: HWND; CueText: PWideChar): BOOL;
TEdit_GetCueBannerText = function (hwnd: HWND; CueText: PWideChar; BufLen: Longint): BOOL;

// on va les utiliser
var
Edit_SetCueBannerText: TEdit_SetCueBannerText;
Edit_GetCueBannerText: TEdit_GetCueBannerText;
{$ifend}

implementation
const
  EM_SETCUEBANNER             = $1501;
  EM_GETCUEBANNER             = $1502;

function Edit_SetCueBannerTextEx(hwnd: HWND; CueText: PWideChar; ShowOnFocus: Boolean = True): BOOL;{$if CompilerVersion >= 20.00} inline; {$ifend}
begin
  Result := BOOL(SendMessage(hwnd, EM_SETCUEBANNER, wParam(ShowOnFocus), lParam(CueText)));
end;
{$if CompilerVersion < 20.00}
function Edit_SetCueBannerText(hwnd: HWND; CueText: PWideChar): BOOL;
begin
  Result := BOOL(SendMessage(hwnd, EM_SETCUEBANNER, wParam(False), lParam(CueText)));
end;

function Edit_GetCueBannerText(hwnd: HWND; CueText: PWideChar; BufLen: Longint): BOOL;
begin
  Result := BOOL(SendMessage(hwnd, EM_GETCUEBANNER, wParam(CueText), lParam(BufLen)));
end;
{$else}
initialization
// redirige les fonctions existantes
Edit_SetCueBannerText := @CommCtrl.Edit_SetCueBannerText;
Edit_GetCueBannerText := @CommCtrl.Edit_GetCueBannerText;

{$ifend}

end.
